/*
 File: TS_la4sym.cpp
 Date and Time: Sat Oct 11 20:57:13 2014 
*/
#include "TS_la4.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_TS_la4;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_TS_la4::TH_TS_la4(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_TS_la4;
  NS_TS_la4::CTS_la4 CTS_la4_;// parallel-parser's parse table
#define ssPARSE_TABLE CTS_la4_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_TS_la4::PROC_TH_TS_la4(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_TS_la4";
  static bool one_time(false);
  static NS_TS_la4::CTS_la4* NS_TS_la4_CTS_la4_(0);// parallel-parser's fsm table
  static Parser* NS_TS_la4_CTS_la4_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_TS_la4_CTS_la4_ = new NS_TS_la4::CTS_la4();// parallel-parser's fsm table
    NS_TS_la4_CTS_la4_parser = new Parser(*NS_TS_la4_CTS_la4_,Caller_pp);
  }
 proc_parser = NS_TS_la4_CTS_la4_parser;
#include "wproc_pp_core.h"
}
void 
CTS_la4::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Reol_:{
       Reol* sym;
     if(re->rule_ == 0){
       sym = new Reol(parser__);
       re->rule_ = sym;
     }else{
       sym = (Reol*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rdelimiters_:{
       Rdelimiters* sym;
     if(re->rule_ == 0){
       sym = new Rdelimiters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdelimiters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rdelimiters_:{
       Rdelimiters* sym;
     if(re->rule_ == 0){
       sym = new Rdelimiters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdelimiters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs3_Rdelimiters_:{
       Rdelimiters* sym;
     if(re->rule_ == 0){
       sym = new Rdelimiters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rdelimiters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    default: return;
   }
}
